package com.pms.ocp.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.pms.ocp.mapper.OcpApiBaseMapper;
import com.pms.ocp.mapper.OcpApiGroupMapper;
import com.pms.ocp.mapper.PmsApiManagementMapper;
import com.pms.ocp.mapper.PmsApiModelRelMapper;
import com.pms.ocp.model.CommonCode;
import com.pms.ocp.model.ResponseResult;
import com.pms.ocp.model.entity.*;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.PmsApiManagementService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class PmsApiManagementServiceImpl extends ServiceImpl<PmsApiManagementMapper, PmsApiManagement> implements PmsApiManagementService {

    @Autowired
    private PmsApiManagementMapper pmsApiManagementMapper;

    @Autowired
    private OcpApiBaseMapper ocpApiBaseMapper;

    @Autowired
    private OcpApiGroupMapper ocpApiGroupMapper;

    @Autowired
    private PmsApiModelRelMapper pmsApiModelRelMapper;



    @Override
    public ResponseVO<PageInfo<PmsApiManagement>> getPammList(PmsApiManagement pmsApiManagement) {
        if (pmsApiManagement.getCurrentPage() ==null || pmsApiManagement.getPageSize() == null) {
            return ResponseVO.error("分页参数不能为空");
        }
        PageHelper.startPage(pmsApiManagement.getCurrentPage(),pmsApiManagement.getPageSize());
        List<PmsApiManagement> pammList = pmsApiManagementMapper.getPammList(pmsApiManagement);
        PageInfo<PmsApiManagement> pageInfo = new PageInfo<>(pammList);
        return ResponseVO.ok(pageInfo);
    }

    @Override
    public ResponseVO getPammByCode(PmsApiManagement pmsApiManagement) {
        List<PmsApiManagement> pammByCode = pmsApiManagementMapper.getPammByCode(pmsApiManagement);
        return ResponseVO.ok(pammByCode);
    }


    @Override
    public ResponseResult UpdatePammByCode(OcpApiBase ocpApiBase) {
        if(ocpApiBase == null){
            ocpApiBase = new OcpApiBase();
        }
        QueryWrapper<OcpApiBase> oab = getCondition(ocpApiBase.getApiCode());
        OcpApiBase one = ocpApiBaseMapper.selectOne(oab);
        if(one != null) {
            ocpApiBase.setObjId(null);
            int update = ocpApiBaseMapper.update(ocpApiBase, oab);
            if (update < 0) {
                return new ResponseResult(CommonCode.FAIL);
            }
            return new ResponseResult(CommonCode.SUCCESS);
        }
        return new ResponseResult(CommonCode.FAIL);
    }
    private QueryWrapper<OcpApiBase> getCondition(String apiCode){
        QueryWrapper<OcpApiBase> qw = new QueryWrapper<>();

        if(StringUtils.isNotBlank(apiCode)){
            qw.eq("api_code",apiCode);
        }
        return qw;
    }

}
